<template>
  <div class="container todo">
    <div class="row todo__header--center">
      <h1 class="title--bold">TODO APP</h1>
    </div>
    <div class="row todo__filter">
      <div class="col-4"></div>
      <div class="col-4 todo__filter__select">
        <select class="form-control" id="exampleFormControlSelect1" v-model="tab">
          <option value="add_new">Add New ToDo</option>
          <!-- <option value="completed">Completed ToDo</option> -->
          <option value="view_and_filter">View And Filter</option>
          <option value="classify_items">Classify Items</option>
        </select>
      </div>
      <div class="col-4"></div>
    </div>
    <div class="row todo__content">
      <div class="col-3"></div>
      <!-- <AddNew v-if="tab === 'add_new'" v-on:display_alert="display_alert" /> -->

      <div class="col-6 content-list">
        <AddNew 
          v-if="tab === 'add_new'" 
          v-on:add_new_item="add_new_item" 
          v-on:enable_update="enable_update" 
          v-on:save_update="save_update"
          v-on:delete_item="delete_item"
          v-on:completed_confirm="completed_confirm"
          v-bind:doing_items="doing_items" 
        />
        <!-- <CompletedToDo 
          v-else-if="tab === 'completed'" 
          v-bind:completed_item="completed_item"
        /> -->
        <ViewAllAndFilter v-else-if="tab==='view_and_filter'" :todo_list="todo_list" />
        <ClassifyItems v-else-if="tab ==='classify_items'" @classify_items_list="classify_items_list" :todo_list="todo_list" />
      </div>
      <div class="col-3"></div>
    </div>
  </div>
</template>

<script>
import "./scss/ToDo.scss";
import AddNew from "./AddNew.vue";
// import CompletedToDo from "./CompletedToDo.vue";
import ViewAllAndFilter from "./ViewAllAndFilter.vue";
import ClassifyItems from "./ClassifyItems.vue";
export default {
  name: "ToDo",
  components: {
    AddNew,
    // CompletedToDo,
    ViewAllAndFilter,
    ClassifyItems
  },
  props: {},
  data() {
    return {
      tab: "add_new",
      todo_list: [],
      completed_item: []
    };
  },
  methods: {
    display_alert(){
      alert("Display alert");
    },
    add_new_item(new_todo){
      if (new_todo == ''){
        alert("You can't add empty value!!!");
        return;
      }
      var added_item = false;
      for (var i = 0; i < this.todo_list.length; i++){
        var item_i = this.todo_list[i];
        if (new_todo == item_i.name){
          added_item = true;
          break;
        }
      }
      if (added_item){
        alert(`${new_todo} was added to todo list!!!`);
      }
      else{
        this.todo_list.push({ id: this.generate_token(), name: new_todo, status: "DOING", disabled: 1 });
        console.log(this.todo_list);
      }
    },
    generate_token() {
      var token = Math.random().toString(36).slice(2);
      return token;
    },
    enable_update(index){
      this.doing_items[index].disabled = 0;
      console.log("check this.todo_list = ", this.todo_list);
    },
    save_update(index, new_name){
      this.doing_items[index].name = new_name;
      this.doing_items[index].disabled = 1;
    },
    delete_item(dlt_item_lst){
      // this.todo_list = this.todo_list.filter(item => dlt_item_lst.indexOf(item.id) == -1);
      for (var i = 0; i < this.todo_list.length; i++){
        if (dlt_item_lst.includes(this.todo_list[i].id)){
          this.todo_list[i].status = "DELETED";
          console.log("check = ", this.todo_list[i]);
        }
      }
      console.log("this.todo_list = ", this.todo_list);
    },
    completed_confirm(cpt_item_lst){
      for (var i = 0; i < this.todo_list.length; i++){
        if (cpt_item_lst.includes(this.todo_list[i].id)){
          this.todo_list[i].status = "COMPLETED";
          console.log("check = ", this.todo_list[i]);
          this.completed_item.push(this.todo_list[i]);
        }
      }
      console.log("this.todo_list = ", this.todo_list);
    },
    classify_items_list(){
      alert("Hello World");
    }
  },
  watch: {
      tab: function(){
        //   alert(this.tab); 
      }
  },
  computed: {
    doing_items(){
      var list_doing = [];
      for (var i = 0; i < this.todo_list.length; i++){
        if (this.todo_list[i].status == "DOING"){
          list_doing.push(this.todo_list[i])
        }
      }
      return list_doing;
    }
  }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
</style>
